import { Filters } from './types';
/**
 * Determines whether a given value should be filtered out or not, using an array of valid include values and invalid exclude values.
 *
 * @param value - The value to check against the include and exclude filters.
 * @param filters - The filters to check the given value against, include and exclude.
 * @returns Whether the value should be filtered out.
 */
export declare function filter<T>(value: T, filters?: Filters<T>): boolean;
/**
 * Exclusive OR.
 *
 * @param lhs - Left hand side.
 * @param rhs - Right hand side.
 * @returns Whether the lhs is true and rhs isn't or rhs is true and lhs isn't.
 */
export declare function xor(lhs: boolean, rhs: boolean): boolean;
/**
 * Check if the value of 2 arrays are equal.
 *
 * @param array1 - First array to compare.
 * @param array2 - Second array to compare.
 * @returns Whether the arrays are equal by value.
 */
export declare function arraysEqual(array1: any[], array2: any[]): boolean;
