import { Capability, Options } from './types';
/**
 * Gets a list of capabilities from BrowserStack's REST API filtered using browser and os options as well as browserslist queries.
 *
 * @param userOptions - The options specified by the user to use when getting capabilites.
 * @returns A list of filtered capabilities.
 */
export default function getCapabilities(userOptions?: Options): Promise<Capability[]>;
export { BrowserFilter, OperatingSystemFilter, WindowsOperatingSystemVersionFilter, OSXOperatingSystemVersionFilter, Options, BrowsersListError, FetchError, ResponseError, } from './types';
