"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.ResponseError = exports.FetchError = exports.BrowsersListError = exports.OSXOperatingSystemVersionFilter = exports.WindowsOperatingSystemVersionFilter = exports.OperatingSystemFilter = exports.BrowserFilter = void 0;
var browserslist_1 = __importDefault(require("browserslist"));
var capabilities_1 = require("./capabilities");
var defaultOptions = {
    username: process.env.BROWSER_STACK_USERNAME,
    accessKey: process.env.BROWSER_STACK_ACCESS_KEY,
    formatForSelenium: true
};
/**
 * Gets a list of capabilities from BrowserStack's REST API filtered using browser and os options as well as browserslist queries.
 *
 * @param userOptions - The options specified by the user to use when getting capabilites.
 * @returns A list of filtered capabilities.
 */
function getCapabilities(userOptions) {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var options, allCapabilities, allSupportedBrowsers, capabilites;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    options = __assign(__assign({}, defaultOptions), userOptions);
                    if (!(options.username && options.accessKey)) return [3 /*break*/, 2];
                    return [4 /*yield*/, capabilities_1.getAllCapabilities(options.username, options.accessKey)];
                case 1:
                    allCapabilities = _c.sent();
                    allSupportedBrowsers = browserslist_1["default"]((_a = options.browserslist) === null || _a === void 0 ? void 0 : _a.queries, (_b = options.browserslist) === null || _b === void 0 ? void 0 : _b.opts).map(function (browserString) {
                        var _a = browserString.split(' '), browser = _a[0], browser_version = _a[1];
                        return {
                            browser: browser,
                            browser_version: !browser_version.includes('.') &&
                                !isNaN(parseFloat(browser_version))
                                ? browser_version + ".0"
                                : browser_version
                        };
                    });
                    capabilites = capabilities_1.filterCapabilities(allCapabilities, allSupportedBrowsers, options);
                    if (options.formatForSelenium) {
                        return [2 /*return*/, capabilites.map(function (capability) {
                                var _a;
                                return (__assign({ browserName: capability.browser, browserVersion: (_a = capability.browser_version) !== null && _a !== void 0 ? _a : undefined }, capability));
                            })];
                    }
                    else {
                        return [2 /*return*/, capabilites];
                    }
                    return [3 /*break*/, 3];
                case 2: throw new TypeError('Missing either `username` or `accessKey`. Pass it via the options object or environment variables (BROWSER_STACK_USERNAME, BROWSER_STACK_ACCESS_KEY)');
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports["default"] = getCapabilities;
var types_1 = require("./types");
__createBinding(exports, types_1, "BrowserFilter");
__createBinding(exports, types_1, "OperatingSystemFilter");
__createBinding(exports, types_1, "WindowsOperatingSystemVersionFilter");
__createBinding(exports, types_1, "OSXOperatingSystemVersionFilter");
__createBinding(exports, types_1, "BrowsersListError");
__createBinding(exports, types_1, "FetchError");
__createBinding(exports, types_1, "ResponseError");
