"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.BrowserFilter = exports.OSXOperatingSystemVersionFilter = exports.WindowsOperatingSystemVersionFilter = exports.OperatingSystemFilter = exports.ResponseError = exports.FetchError = exports.BrowsersListError = void 0;
var error_1 = __importDefault(require("browserslist/error"));
exports.BrowsersListError = error_1["default"];
var node_fetch_1 = require("node-fetch");
exports.FetchError = node_fetch_1.FetchError;
/**
 * Thrown if node-fetch response status is not >= 200 < 300.
 */
var ResponseError = /** @class */ (function (_super) {
    __extends(ResponseError, _super);
    /**
     * Creates a new ResponseError instance.
     *
     * @param statusText - The message returned by the server.
     * @param status - The HTTP status code returned by the server.
     */
    function ResponseError(statusText, status) {
        var _newTarget = this.constructor;
        var _this = _super.call(this, statusText + " (" + status + ")") || this;
        _this.status = status;
        _this.name = _this.constructor.name;
        Object.setPrototypeOf(_this, _newTarget.prototype);
        Error.captureStackTrace(_this, _this.constructor);
        return _this;
    }
    return ResponseError;
}(Error));
exports.ResponseError = ResponseError;
var OperatingSystemFilter;
(function (OperatingSystemFilter) {
    OperatingSystemFilter["WINDOWS"] = "Windows";
    OperatingSystemFilter["OSX"] = "OS X";
})(OperatingSystemFilter = exports.OperatingSystemFilter || (exports.OperatingSystemFilter = {}));
var WindowsOperatingSystemVersionFilter;
(function (WindowsOperatingSystemVersionFilter) {
    WindowsOperatingSystemVersionFilter["XP"] = "XP";
    WindowsOperatingSystemVersionFilter["SEVEN"] = "7";
    WindowsOperatingSystemVersionFilter["EIGHT"] = "8";
    WindowsOperatingSystemVersionFilter["EIGHT_ONE"] = "8.1";
    WindowsOperatingSystemVersionFilter["TEN"] = "10";
})(WindowsOperatingSystemVersionFilter = exports.WindowsOperatingSystemVersionFilter || (exports.WindowsOperatingSystemVersionFilter = {}));
var OSXOperatingSystemVersionFilter;
(function (OSXOperatingSystemVersionFilter) {
    OSXOperatingSystemVersionFilter["SNOW_LEOPARD"] = "Snow Leopard";
    OSXOperatingSystemVersionFilter["LION"] = "Lion";
    OSXOperatingSystemVersionFilter["MOUNTAIN_LION"] = "Mountain Lion";
    OSXOperatingSystemVersionFilter["MAVERICKS"] = "Mavericks";
    OSXOperatingSystemVersionFilter["YOSEMITE"] = "Yosemite";
    OSXOperatingSystemVersionFilter["EL_CAPITAN"] = "El Capitan";
    OSXOperatingSystemVersionFilter["SIERRA"] = "Sierra";
    OSXOperatingSystemVersionFilter["HIGH_SIERRA"] = "High Sierra";
    OSXOperatingSystemVersionFilter["MOJAVE"] = "Mojave";
    OSXOperatingSystemVersionFilter["CATALINA"] = "Catalina";
})(OSXOperatingSystemVersionFilter = exports.OSXOperatingSystemVersionFilter || (exports.OSXOperatingSystemVersionFilter = {}));
var BrowserFilter;
(function (BrowserFilter) {
    BrowserFilter["FIREFOX"] = "firefox";
    BrowserFilter["SAFARI"] = "safari";
    BrowserFilter["IE"] = "ie";
    BrowserFilter["CHROME"] = "chrome";
    BrowserFilter["OPERA"] = "opera";
    BrowserFilter["EDGE"] = "edge";
})(BrowserFilter = exports.BrowserFilter || (exports.BrowserFilter = {}));
